<?php
namespace Avaliacao\Entities;

use Avaliacao\Repositories;
use Geral\Util\DateUtil;
use Geral\Util\NovoCodigo;
use Setforms2\Shared\Registry;

class AvlRespquestaval extends Base\AvlRespquestaval
{
    public static function retornaRespQuestAval($nrorg, $nravaliacao, $nrquestao, $txcomplementoquestao, $nrtemaanalise){
        $nrquestao = ($nrquestao) ? ' = '.$nrquestao : 'IS NULL';
        $txcomplementoquestao = ($txcomplementoquestao) ? " = '$txcomplementoquestao'" : 'IS NULL';
        $nrtemaanalise = ($nrtemaanalise) ? " = '$nrtemaanalise'" : 'IS NULL';
        $result = Repositories\AvlRespquestaval::retornaRespQuestAval($nrorg, $nravaliacao, $nrquestao, $txcomplementoquestao, $nrtemaanalise);
        return $result;
    }

    public function incluiRespostasAvaliacao
    (
        $nrorg,
        $nravaliacao,
        $nrresposta,
        $qt_votos = null,
        $txcomplementoquestao = null,
        $nrtemaanalise = null
    ){
        try {
            $obj = new self();
            $obj->setNrrespquestaval((NovoCodigo::geraCodigo($nrorg, 'AVL_RESPQUESTAVAL',1,10,true)));
            $obj->setNrresposta($nrresposta);
            $obj->setNravaliacao($nravaliacao);
            $obj->setQtrespquesaval($qt_votos);
            $obj->setDtinclusao(DateUtil::getDataAtual());
            $obj->setTxcomplementoquestao($txcomplementoquestao);
            $obj->setNrtemaanalise($nrtemaanalise);
            $obj->setIdativo('S');
            $obj->setNrorg($nrorg);
            $obj->setNrorginclusao($nrorg);
            $obj->persist();

            Registry::getEntityManager()->flush();

            return true;

        } catch (\Exception $e){
            tk_warning($e->getMessage());
            return false;
        }
    }

    public function incrementaQuantidadeVotosAvaliacao($nrorg, $nravaliacao, $txcomplementoquestao, $tema_analise, $nrresposta, $qt_votos) {
        $lista_resposta = AvlRespquestaval::getObjectsByWhere(
            'NRORG = ? AND NRAVALIACAO = ? AND NRRESPOSTA = ?' . $txcomplementoquestao . $tema_analise,
            array(
                $nrorg,
                $nravaliacao,
                $nrresposta,
            )
        );
        foreach ($lista_resposta as $resposta) {
            /** @var $resposta AvlRespquestaval */
            $resposta->setQtrespquesaval($qt_votos);
            $resposta->persist();
        }
        return true;
    }

    public static function excluiRespQuestAval($nrorg, $nravaliacao, $nrquestao, $txcomplementoquestao, $tema_analise){
        try {
            $txcomplementoquestao = ($txcomplementoquestao) ? " = '$txcomplementoquestao'": 'IS NULL';
            $tema_analise = ($tema_analise) ? " = $tema_analise": 'IS NULL';
            Repositories\AvlRespquestaval::query_excluiRespQuestAval($nrorg, $nravaliacao, $nrquestao, $txcomplementoquestao, $tema_analise);
        } catch(\Exception $e) {
            return false;
        }
        return true;
    }

    public static function consultaQuantidadeRealVotosPorQuestao($nrorg, $nravaliacao) {
        $query = "SELECT SUM(AVL_RESPQUESTAVAL.QTRESPQUESAVAL) AS QT_TOTAL_VOTOS
                    FROM AVL_RESPQUESTAVAL, RESPOSTA, QUESTAVALIACAO
                   WHERE AVL_RESPQUESTAVAL.NRORG = {$nrorg}
                     AND AVL_RESPQUESTAVAL.NRAVALIACAO = {$nravaliacao}
                     AND AVL_RESPQUESTAVAL.NRORG = RESPOSTA.NRORG
                     AND AVL_RESPQUESTAVAL.NRRESPOSTA = RESPOSTA.NRRESPOSTA
                     AND AVL_RESPQUESTAVAL.NRORG = QUESTAVALIACAO.NRORG
                     AND (AVL_RESPQUESTAVAL.TXCOMPLEMENTOQUESTAO = QUESTAVALIACAO.TXCOMPLEMENTOQUESTAO
                       OR QUESTAVALIACAO.TXCOMPLEMENTOQUESTAO IS NULL)
                     AND (AVL_RESPQUESTAVAL.NRTEMAANALISE = QUESTAVALIACAO.NRTEMAANALISE
                       OR QUESTAVALIACAO.NRTEMAANALISE IS NULL)
                     AND QUESTAVALIACAO.NRCOMBQUESTAVAL IN (SELECT NRCOMBQUESTAVAL FROM COMBQUESTAVAL WHERE NRAVALIACAO = {$nravaliacao})
                     AND RESPOSTA.NRORG = QUESTAVALIACAO.NRORG
                     AND RESPOSTA.NRQUESTAO = QUESTAVALIACAO.NRQUESTAO
                     GROUP BY QUESTAVALIACAO.NRQUESTAO";
        $result = \Setforms2\Runtime\Framework::getInstance()->fetchAll($query);
        return $result;
    }

    public static function excluiRespostasQuestaoAvaliacao($nrorg, $nravaliacao) {
        try {
            $sql = "DELETE FROM AVL_RESPQUESTAVAL
                     WHERE NRORG = {$nrorg}
                       AND NRAVALIACAO = {$nravaliacao}";
            \Setforms2\Shared\Connection::getInstance()->execute($sql);
            return true;
        } catch(\Exception $e) {
            return false;
        }
    }
}