<?php
namespace Fiscal\Logic\NotaFiscalEletronica;

use Fiscal\Entities\Notafiscal;
use Geral\Entities\Empresa;
use Geral\Util\Ambiente;
use Geral\Util\DateUtil;
use Geral\Util\TratamentoDeMensagens;
use Indeterminado\Entities\Numinutilnfele;
use Setforms2\Shared\Registry;

class InutilizacaoNfe
{
    public static function inutilizar($row, Empresa $empresa, $inscricaoEstadual, $inscricaoMunicipal, $ano, $serie, $justificativa, $cnpj, $ambiente){
        try{
            $toolsnfe = new ToolsNFePHP($empresa, $inscricaoEstadual);
            $inut = $toolsnfe->inutNF($ano, $serie, ltrim($row['INTERVALOINI'], '0'), ltrim($row['INTERVALOFIN'], '0'), $justificativa);
            if($inut){
                if($inut['cStat'] == '102'){
                    for($numero = $row['INTERVALOINI']; $numero <= $row['INTERVALOFIN']; $numero++){
                        self::insNumInut($empresa->getCdempresa(), $cnpj, $serie, $numero, $ambiente, DateUtil::getDataDeString(substr($inut['dhRecbto'], 0, 10)), $inscricaoEstadual, $inscricaoMunicipal, $inut['nProt'], '1', $justificativa);
                    }
                    Notafiscal::getRepository()->updGravaIntInutNFe('A', $inut['xMotivo'], $empresa->getCdempresa(), $serie, $row['INTERVALOINI'], $row['INTERVALOFIN'], $cnpj, $ambiente);
                }
                else{
                    Notafiscal::getRepository()->updGravaIntInutNFe('R', $inut['xMotivo'], $empresa->getCdempresa(), $serie, $row['INTERVALOINI'], $row['INTERVALOFIN'], $cnpj, $ambiente);
                }
                Registry::getEntityManager()->flush();
                return $inut;
            }
            else{
                return $toolsnfe->errMsg;
            }
        }catch(\Exception $e){
            TratamentoDeMensagens::exibirMensagens($e);
        }
    }

    public static function insNumInut($empresa, $cnpj, $serie, $numero, $ambiente, $data, $inscricaoEstadual, $inscricaoMunicipal, $prot, $tipoEmissao, $justificativa){
        $numinutilnfele = new Numinutilnfele();

        $numinutilnfele->setCdempresa($empresa);
        $numinutilnfele->setNrinsjuriestnfe($cnpj);
        $numinutilnfele->setCdserie($serie);
        $numinutilnfele->setNrinutilnfele($numero);
        $numinutilnfele->setIdtpambnfenum($ambiente);
        $numinutilnfele->setDtinutnfe($data);
        $numinutilnfele->setCdinscesta($inscricaoEstadual);
        $numinutilnfele->setCdinscmuni($inscricaoMunicipal);
        $numinutilnfele->setNrprotocinutnfe($prot);
        $numinutilnfele->setIdtpemisinutil($tipoEmissao);
        $numinutilnfele->setDsjusnuminutilnfe($justificativa);

        $numinutilnfele->setNrorg(Ambiente::getNrorg());
        $numinutilnfele->setCdoperinclusao(Ambiente::getCdOperador());
        $numinutilnfele->setCdoperultatu(Ambiente::getCdOperador());
        $numinutilnfele->setDtinclusao(DateUtil::getDataAtual());
        $numinutilnfele->setDtultatu(DateUtil::getDataAtual());

        $numinutilnfele->persist();
    }
}