<?php
namespace Relatione\Logic;
/**
 * Created by JetBrains PhpStorm.
 * User: marcellichtnow
 * Date: 05/06/13
 * Time: 17:39
 * To change this template use File | Settings | File Templates.
 */
class FilaContatoLogic
{

    public function verificaContato($nrseqcontato)
    {
        $params = array("NRSEQCONTATO" => $nrseqcontato,
                        "NRORG" => \Geral\Util\Ambiente::getNrorg());
        $sql = 'SELECT NRSEQOPORT FROM CRM_OPORTUNI
                 WHERE NRSEQCONTATO = :NRSEQCONTATO
                   AND NRORG = :NRORG';
        
        $aux = \Setforms2\Shared\Registry::getEntityManager()->getConnection()->fetchAll($sql, $params);

        if(count($aux) > 0)
        {
           $nrseqoport = $aux[0]['NRSEQOPORT'];

           return $nrseqoport;
        }
        else
            {return $nrseqcontato;}
    }

    public function verificaNrseqfasenego($nrcontato)
    {
        $params = array("NRCONTATO" => $nrcontato,
                        "NRORG" => \Geral\Util\Ambiente::getNrorg());
        $sql = 'SELECT NRSEQFASENEGO FROM CRM_OPORTUNI
                 WHERE NRCONTATO = :NRCONTATO
                   AND NRORG = :NRORG';
        
        $aux = \Setforms2\Shared\Registry::getEntityManager()->getConnection()->fetchAll($sql, $params);

        if(count($aux) > 0)
        {
           $nrseqfasenego = $aux[0]['NRSEQFASENEGO'];

           return $nrseqfasenego;
        }
    }

    public function setaIdativoBanco($nrseqfilaconta,$nrorg){

        try {
            $params = array(
                "DTREALFILACONTA" => now(),
                "NRSEQFILACONTA" => $nrseqfilaconta,
                "NRORG" => $nrorg
            );

            $sql = 'update FILACONTATO
                     set DTREALFILACONTA = :DTREALFILACONTA
                     where NRSEQFILACONTA = :NRSEQFILACONTA
                     AND NRORG = :NRORG';

            \Setforms2\Runtime\Connection::getInstance()->execute($sql, $params);

        } catch (\Exception $e) {
            tk_warning($e->getMessage());
        }


    }
    
      public function setaNovaTarefa($novonrseqfilaconta,$nrorg,$dthrproxativ,$cdoperevol,$nrcontato,$nrparcnegocio,$dsfilacontato, $proxativ = null, $nrseqcontato = null){
          /** @var $tarefa \Relatione\Entities\Filacontato */
          if($dthrproxativ!=null)
            {$dthrproxativ = \Geral\Util\DateUtil::getDataDeString($dthrproxativ,\Geral\Util\DateUtil::FORMATO_BRASILEIRO_DATAHORA);
            $tarefa = new \Relatione\Entities\Filacontato();
            $tarefa->setNrorg($nrorg);
            $tarefa->setNrorginclusao($nrorg);
            $tarefa->setNrseqfilaconta($novonrseqfilaconta);
            $tarefa->setDtplanfilaconta($dthrproxativ);
            $tarefa->setDsfilacontato($dsfilacontato);
            $tarefa->setNrpriorfilacont(2);
            $tarefa->setCdoperreal($cdoperevol);
            $tarefa->setNrcontato($nrcontato);
            $tarefa->setNrparcnegocio($nrparcnegocio);
            $tarefa->setIdorigfilaconta('M');
            $tarefa->setDtinclusao(\Geral\Util\DateUtil::getDataDeString(tk_get_field_value('DTINCLUSAO'),\Geral\Util\DateUtil::FORMATO_BRASILEIRO_DATAHORA));
            $tarefa->setCdoperinclusao(\Geral\Util\Ambiente::getCdOperador());
            //$tarefa->setIdativo('S');
            $tarefa->setNrseqcontato($nrseqcontato);
            $tarefa->setCdfilial('9999');
            $tarefa->persist();
            \Setforms2\Shared\Registry::getEntityManager()->flush();
            }

    }
    public function getContato($nrcontato){
                $contato = \Geral\Entities\Contato::getObject(array('nrcontato'=>$nrcontato,'nrorg'=>\Geral\Util\Ambiente::getNrorg(),'cdfilial'=>'9999'));
                return $contato;
    }
    public function getIdproxativ($nrseqresulevol){
                $idgerproxativ = \Relatione\Entities\CrmResultevol::getObject(array('nrseqresulevol'=>$nrseqresulevol,'nrorg'=>\Geral\Util\Ambiente::getNrorg()));
                return $idgerproxativ;
    }


    public static function enviaEmail(){
        $operAtual = \Geral\Util\Ambiente::getCdoperador();
        $operInclusao = tk_get_field_value('CDOPERINCLUSAO');
        $operResponsavel = tk_get_field_value('CDOPERREAL');
        if(($operAtual == $operInclusao)||($operAtual == $operResponsavel)){
           $yes['label'] = 'Sim';
           $yes['method'] = array("\\Relatione\\Logic\\FilaContatoLogic", "enviar");
           $yes["params_arr"] = array();
           $no['label'] = 'Não';

        tk_confirm('Deseja enviar email para Responsável?', $yes, $no);
        }else{
            tk_abort('Esta opção está disponível apenas para o operador responsável.');

        }
    }

    public static function enviar($cancelado = null){
        try{
            $operador = \Geral\Entities\Operador::getObjectByWhere("NRORG ='".\Geral\Util\Ambiente::getNrorg()."' AND IDOPERATIVO = 'A' AND CDOPERADOR = '".tk_get_field_value('CDOPERREAL')."'");
            $oper[] = $operador->getDsemailoper();
            $para = $oper;
            $remetente = \Geral\Entities\Operador::getObject(array("cdoperador"=>\Geral\Util\Ambiente::getCdOperador(),"nrorg"=>\Geral\Util\Ambiente::getNrorg()));
            $parceiro = "";
            $nrparc = tk_get_field_value('NRPARCNEGOCIO');
            if(!empty($nrparc))
                {$parceiro = "<br><b>Parceiro de Negócio: </b>".tk_get_field_value('NRPARCNEGOCIO')." - ".tk_get_field_value('NMPARCNEGOCIO');}
                $mensagem = "<html>
                               <head>
                                     <title></title>

                               </head>

                               <body>
                                   <br><b>Responsável: </b>".$remetente->getNmoperador().
                                   $parceiro."
                                   <br><b>Data/Hora Tarefa: </b>".tk_get_field_value("DTPLANFILACONTA")."
                                   <br>--------------------------------------------------------------------------------------------
                                   <br><b>Descrição da Tarefa:</b><br>".tk_get_field_value("DSDETEFILACONTA")."
                                   

                                   </ul>
                                   <br>--------------------------------------------------------------------------------------------

                               </body>
                            </html>";

            $assunto = "Tarefa: ".tk_get_field_value('DSFILACONTATO');
            $tamanho = count($para);
            $remet = $remetente->getDsemailoper();
            if($tamanho > 0)
                if($remet != '')
                    \Relatione\Logic\FilaContatoLogic::email($remet, $para, $assunto, $mensagem);
        }catch(\Exception $e){
            tk_warning($e->getMessage());
        }

    }

    public static function email($de,$para,$assunto,$mensagem){

        $envio = \Setforms2\Shared\Notifier::factory();

        $notification = new \Setforms2\Shared\Business\Notification();
        $notification->setSubject($assunto);
        $notification->setFrom($de);
        $notification->setTo($para);
        $notification->setBody($mensagem);
        $envio->setNotificationBusiness($notification);
        $envio->send();
    }
}
