create or replace PROCEDURE IMPORTA_PARAMPRATFILIAL_XLS (
   P_NRIMPPARAMPRATFILIAL IN NUMBER,
   P_CDFILIAL IN VARCHAR2,
   P_CDSERVFILI IN VARCHAR2,
   P_IDTIPORESTRICAO IN VARCHAR2,
   P_IDUTRPADCA IN VARCHAR2,
   P_RETORNO OUT NUMBER
) IS
   V_RETORNO NUMBER;
   V_STATUS VARCHAR2(6);
   V_COLUNAS_MODIFICADAS BOOLEAN;
   V_COMPLEXIDADE VARCHAR2(30);
   V_IDPREPREPARO VARCHAR2(1);
   V_COR VARCHAR2(30);
   V_INGREDIENTEPRINC1 NUMBER;
   V_INGREDIENTEPRINC2 NUMBER;
   V_APRERECE VARCHAR2(3);
   V_FORMAPREPARO NUMBER;
   V_ATRATIVIDADEPRATO NUMBER;
   V_NRGRUPOPRATOSERV NUMBER;
   V_NRITGRUPOPRATOSERV NUMBER;
   V_NRORG NUMBER;
   PROCEDURE INSERE_LISTA_ERRO (
      P_INDICE IN VARCHAR2,
      P_DESCRICAO IN VARCHAR2,
      P_STATUS OUT VARCHAR2
   ) IS
   BEGIN
      IF V_RETORNO IS NULL THEN
         NOVO_CODIGO('LOG_IMP_PARAMPRATFI',V_RETORNO, 1, V_NRORG);
      END IF;
      INSERT INTO LOG_IMP_PARAMPRATFI(DSLOGIMPARAMPRATFI,NRLOGIMPARAMPRATFI, NRORG, NRORGINCLUSAO, NRORGULTATU) VALUES ('Linha: '||P_INDICE||' - '||P_DESCRICAO,V_RETORNO, V_NRORG, V_NRORG, V_NRORG);
      P_STATUS := 'ERRO';
   END INSERE_LISTA_ERRO;

   FUNCTION MODIFICADO(P_PARAM1 VARCHAR2, P_PARAM2 VARCHAR2)
   RETURN BOOLEAN IS
   BEGIN
   RETURN UPPER(NVL(P_PARAM1, ' ')) <> UPPER(NVL(P_PARAM2, ' '));
   END;

   FUNCTION COLUNAS_MODIFICADAS(
        p_XLS_NMGRUPOPRATO VARCHAR2,
        p_NMGRUPOPRATO VARCHAR2,
        p_XLS_IDCOMPLEXIDADE VARCHAR2,
        p_IDCOMPLEXIDADE VARCHAR2,
        p_XLS_IDPREPREPARO VARCHAR2,
        p_IDPREPREPARO VARCHAR2,
        p_XLS_IDCOR VARCHAR2,
        p_IDCOR VARCHAR2,
        p_XLS_NMINGREDIENTEPRINC1 VARCHAR2,
        p_NMINGREDIENTEPRINC1 VARCHAR2,
        p_XLS_NMINGREDIENTEPRINC2 VARCHAR2,
        p_NMINGREDIENTEPRINC2 VARCHAR2,
        p_XLS_NMAPRERECE VARCHAR2,
        p_TIPOCORTE VARCHAR2,
        p_XLS_NMFORMAPREPARO VARCHAR2,
        p_NMFORMAPREPARO VARCHAR2,
        p_XLS_NMATRATIVIDADEPRATO VARCHAR2,
        p_NMATRATIVIDADEPRATO VARCHAR2
    ) RETURN BOOLEAN IS
    BEGIN
        IF MODIFICADO(p_XLS_NMGRUPOPRATO, p_NMGRUPOPRATO) THEN
            RETURN TRUE;
        END IF;
        IF MODIFICADO(p_XLS_IDCOMPLEXIDADE, p_IDCOMPLEXIDADE) THEN
            RETURN TRUE;
        END IF;
        IF MODIFICADO(p_XLS_IDPREPREPARO, p_IDPREPREPARO) THEN
            RETURN TRUE;
        END IF;
        IF MODIFICADO(p_XLS_IDCOR, p_IDCOR) THEN
            RETURN TRUE;
        END IF;
        IF MODIFICADO(p_XLS_NMINGREDIENTEPRINC1, p_NMINGREDIENTEPRINC1) THEN
            RETURN TRUE;
        END IF;
        IF MODIFICADO(p_XLS_NMINGREDIENTEPRINC2, p_NMINGREDIENTEPRINC2) THEN
            RETURN TRUE;
        END IF;
        IF MODIFICADO(p_XLS_NMAPRERECE, p_TIPOCORTE) THEN
            RETURN TRUE;
        END IF;
        IF MODIFICADO(p_XLS_NMFORMAPREPARO, p_NMFORMAPREPARO) THEN
            RETURN TRUE;
        END IF;
        IF MODIFICADO(p_XLS_NMATRATIVIDADEPRATO, p_NMATRATIVIDADEPRATO) THEN
            RETURN TRUE;
        END IF;
        RETURN FALSE;
    END;
BEGIN
   V_NRORG := SYS_CONTEXT('nrorg_ctx','nrorg'); 
   FOR C_PLANILHA IN (SELECT I.NRIMPPARAMPRATFILIAL, I.NRINDICE, I.CDFILIAL, I.CDFILAUXPRAT, I.CDPRATO, P.CDPRATO AS PRATO_EXISTE, I.NMGRUPOPRATO AS XLS_NMGRUPOPRATO,  I.IDCOMPLEXIDADE AS XLS_IDCOMPLEXIDADE,
                             I.IDPREPREPARO AS XLS_IDPREPREPARO, I.IDCOR AS XLS_IDCOR, I.NMINGREDIENTEPRINC1 AS XLS_NMINGREDIENTEPRINC1, I.NMINGREDIENTEPRINC2 AS XLS_NMINGREDIENTEPRINC2, I.NMAPRERECE AS XLS_NMAPRERECE, 
                             I.NMFORMAPREPARO AS XLS_NMFORMAPREPARO, I.NMATRATIVIDADEPRATO AS XLS_NMATRATIVIDADEPRATO, G.NRGRUPOPRATOSERV,
                             G.NMGRUPOPRATO, G.NRITGRUPOPRATOSERV, PF.IDCOMPLEXIDADE, PF.IDPREPREPARO, PF.IDCOR, PF.NRINGREDIENTEPRINC1, I1.NMINGREDIENTEPRINC AS NMINGREDIENTEPRINC1, PF.NRINGREDIENTEPRINC2,
                             I2.NMINGREDIENTEPRINC AS NMINGREDIENTEPRINC2, PF.CDAPRERECE, AP.NMAPRERECE, PF.NRFORMAPREPARO, FF.NMFORMAPREPARO, PF.NRATRATIVIDADEPRATO, AT.NMATRATIVIDADEPRATO,
                             PF.CDFILAUXPRAT AS PRATO_PARAMETRIZADO, P.IDATIVO
                        FROM IMP_PARAMPRATFILIAL I LEFT JOIN PRATO P ON I.CDFILAUXPRAT = P.CDFILAUXPRAT AND I.CDPRATO = P.CDPRATO
                                                   LEFT  JOIN PARAMPRATFILIAL PF ON PF.CDFILAUXPRAT = I.CDFILAUXPRAT AND PF.CDPRATO = I.CDPRATO AND PF.CDFILIAL = I.CDFILIAL
                                                   LEFT  JOIN APRERECE AP ON AP.CDAPRERECE = PF.CDAPRERECE
                                                   LEFT  JOIN FORMAPREPARO FF ON FF.NRFORMAPREPARO = PF.NRFORMAPREPARO
                                                   LEFT  JOIN ATRATIVIDADEPRATO AT ON AT.NRATRATIVIDADEPRATO = PF.NRATRATIVIDADEPRATO
                                                   LEFT  JOIN INGREDIENTEPRINC I1 ON I1.NRINGREDIENTEPRINC = PF.NRINGREDIENTEPRINC1
                                                   LEFT  JOIN INGREDIENTEPRINC I2 ON I2.NRINGREDIENTEPRINC = PF.NRINGREDIENTEPRINC2
                                                   LEFT JOIN (SELECT GS.NRGRUPOPRATOSERV, G.NMGRUPOPRATO, IT.NRITGRUPOPRATOSERV, IT.CDPRATO, IT.CDFILAUXPRAT
                                                                FROM GRUPOPRATO G INNER JOIN GRUPOPRATOSERV GS ON G.NRGRUPOPRATO = GS.NRGRUPOPRATO AND G.IDTIPORESTRICAO = P_IDTIPORESTRICAO AND G.CDFILIAL = P_CDFILIAL AND GS.CDSERVFILI = P_CDSERVFILI
                                                                                  INNER JOIN ITGRUPOPRATOSERV IT ON IT.NRGRUPOPRATOSERV = GS.NRGRUPOPRATOSERV 
                                                             ) G ON G.CDFILAUXPRAT = I.CDFILAUXPRAT AND G.CDPRATO = I.CDPRATO
                       WHERE I.NRIMPPARAMPRATFILIAL = P_NRIMPPARAMPRATFILIAL AND I.CDFILIAL = P_CDFILIAL AND
                             (EXISTS (SELECT 1 
                                        FROM RECESERV RS LEFT JOIN PRATSERV PS ON RS.CDPRATO = PS.CDPRATO AND RS.CDFILAUXPRAT = PS.CDFILAUXPRAT AND RS.CDFILIAL = PS.CDFILIAL AND RS.CDSERVFILI = PS.CDSERVFILI
                                       WHERE RS.CDFILIAL = P_CDFILIAL AND RS.CDSERVFILI = P_CDSERVFILI AND RS.CDPRATO = I.CDPRATO AND RS.CDFILAUXPRAT = I.CDFILAUXPRAT AND NVL(PS.IDATIVO, 'S') = 'S') OR 
                              EXISTS (SELECT 1
                                        FROM RECEFILI RF LEFT JOIN PRATFILI PF ON RF.CDPRATO = PF.CDPRATO AND RF.CDFILAUXPRAT = PF.CDFILAUXPRAT AND RF.CDFILIAL = PF.CDFILIAL
                                       WHERE RF.CDFILIAL = P_CDFILIAL AND RF.CDPRATO = I.CDPRATO AND RF.CDFILAUXPRAT = I.CDFILAUXPRAT AND NVL(PF.IDATIVO, 'S') = 'S') OR 
                              EXISTS (SELECT 1 
                                        FROM RECEPADR RP LEFT JOIN PRATPADR PP ON RP.CDPRATO = PP.CDPRATO AND RP.CDFILAUXPRAT = PP.CDFILAUXPRAT
                                       WHERE RP.CDPRATO = I.CDPRATO AND RP.CDFILAUXPRAT = I.CDFILAUXPRAT AND NVL(PP.IDATIVO, 'S') = 'S' AND P_IDUTRPADCA = 'S'))
   )LOOP
      V_STATUS := 'OK';

      IF C_PLANILHA.PRATO_EXISTE IS NULL OR C_PLANILHA.IDATIVO = 'N' THEN
         INSERE_LISTA_ERRO(C_PLANILHA.NRINDICE,'prato_invalido',V_STATUS);
      END IF;

      V_COLUNAS_MODIFICADAS := COLUNAS_MODIFICADAS(C_PLANILHA.XLS_NMGRUPOPRATO,C_PLANILHA.NMGRUPOPRATO, C_PLANILHA.XLS_IDCOMPLEXIDADE,C_PLANILHA.IDCOMPLEXIDADE,C_PLANILHA.XLS_IDPREPREPARO,C_PLANILHA.IDPREPREPARO,C_PLANILHA.XLS_IDCOR,
                                                           C_PLANILHA.IDCOR, C_PLANILHA.XLS_NMINGREDIENTEPRINC1, C_PLANILHA.NMINGREDIENTEPRINC1, C_PLANILHA.XLS_NMINGREDIENTEPRINC2, C_PLANILHA.NMINGREDIENTEPRINC2, C_PLANILHA.XLS_NMAPRERECE,
                                                           C_PLANILHA.NMAPRERECE, C_PLANILHA.XLS_NMFORMAPREPARO, C_PLANILHA.NMFORMAPREPARO, C_PLANILHA.XLS_NMATRATIVIDADEPRATO, C_PLANILHA.NMATRATIVIDADEPRATO);
      /*SE A LINHA DA PLANILHA NAO TEVE ALTERACAO PULA PARA A PROXIMA*/
      IF(V_COLUNAS_MODIFICADAS = FALSE) THEN
         CONTINUE;
      END IF;
      
      /*VALIDACAO DE COMPLEXIDADE*/
      IF MODIFICADO(C_PLANILHA.XLS_IDCOMPLEXIDADE, C_PLANILHA.IDCOMPLEXIDADE) THEN
         IF(UPPER(NVL(C_PLANILHA.XLS_IDCOMPLEXIDADE,'BAIXA')) NOT IN ('BAIXA','MEDIA','ALTA'))THEN
            INSERE_LISTA_ERRO(C_PLANILHA.NRINDICE,'complexidade_invalida',V_STATUS);
         ELSE
            V_COMPLEXIDADE := UPPER(NVL(C_PLANILHA.XLS_IDCOMPLEXIDADE,'BAIXA'));
         END IF;
      ELSE
         V_COMPLEXIDADE := C_PLANILHA.IDCOMPLEXIDADE;
      END IF;
      
      /*VALIDACAO DE PRE PREPARO*/
      IF MODIFICADO(C_PLANILHA.XLS_IDPREPREPARO, C_PLANILHA.IDPREPREPARO) THEN
         IF(UPPER(NVL(C_PLANILHA.XLS_IDPREPREPARO,'N')) NOT IN ('N','S','NO','NAO','NO','SIM','SI','S','Y','YES'))THEN
            INSERE_LISTA_ERRO(C_PLANILHA.NRINDICE,'pre_preparo_invalido',V_STATUS);
         ELSE
            V_IDPREPREPARO := UPPER(SUBSTR(NVL(C_PLANILHA.XLS_IDPREPREPARO,'N'),1,1));
         END IF;
      ELSE
        V_IDPREPREPARO := C_PLANILHA.IDPREPREPARO;
      END IF;
      
      /*VALIDACAO DE COR*/
      IF MODIFICADO(C_PLANILHA.XLS_IDCOR, C_PLANILHA.IDCOR) THEN
         IF(C_PLANILHA.XLS_IDCOR IS NOT NULL) THEN
            IF (UPPER(C_PLANILHA.XLS_IDCOR) NOT IN ('NA','VERMELHO','AMARELO','BRANCO','VERDE','ROXO','BEGE','COLORIDA(O)','MARROM','LARANJA','DOURADO','ROSA','CASTANHO CLARO','PRETO','VERDE CLARO','ROSA CLARO','CARAMELO',
                                                    'AMARELO CLARO','VERDE ESCURO','CORAL','SALMAO','AMARELO ESCURO','COBRE','VERMELHO ESCURO','VERMELHO ENEGRECIDO','ROSA ESCURO','FERRUGEM','LILAS','AZUL','PARDO'))THEN
               INSERE_LISTA_ERRO(C_PLANILHA.NRINDICE,'cor_invalida',V_STATUS);
            ELSE
               V_COR := UPPER(C_PLANILHA.XLS_IDCOR);
            END IF;   
         ELSE
            V_COR := NULL;
         END IF;
      ELSE
         V_COR := C_PLANILHA.IDCOR;
      END IF;
      
      /*INGREDIENTE PRINCIPAL 1*/
      IF MODIFICADO(C_PLANILHA.XLS_NMINGREDIENTEPRINC1, C_PLANILHA.NMINGREDIENTEPRINC1) THEN
         IF(C_PLANILHA.XLS_NMINGREDIENTEPRINC1 IS NULL OR TRIM(C_PLANILHA.XLS_NMINGREDIENTEPRINC1) = '')  THEN
            V_INGREDIENTEPRINC1 := NULL;
         ELSE
            BEGIN
               SELECT MAX(NRINGREDIENTEPRINC) 
                 INTO V_INGREDIENTEPRINC1
                 FROM INGREDIENTEPRINC 
                WHERE UPPER(NMINGREDIENTEPRINC) = UPPER(C_PLANILHA.XLS_NMINGREDIENTEPRINC1);
            EXCEPTION 
                WHEN NO_DATA_FOUND THEN
                   V_INGREDIENTEPRINC1 := NULL;
            END;
            IF (V_INGREDIENTEPRINC1 IS NULL) THEN
                BEGIN
                   NOVO_CODIGO('INGREDIENTEPRINC',V_INGREDIENTEPRINC1, 1, V_NRORG);
                   INSERT INTO INGREDIENTEPRINC(NRINGREDIENTEPRINC, NMINGREDIENTEPRINC, NRORG, NRORGULTATU, NRORGINCLUSAO) VALUES (V_INGREDIENTEPRINC1, C_PLANILHA.XLS_NMINGREDIENTEPRINC1, V_NRORG, V_NRORG, V_NRORG);
                END;
            END IF;
         END IF;
      ELSE
         V_INGREDIENTEPRINC1 := C_PLANILHA.NRINGREDIENTEPRINC1;
      END IF;

      /*INGREDIENTE PRINCIPAL 2*/
      IF MODIFICADO(C_PLANILHA.XLS_NMINGREDIENTEPRINC2, C_PLANILHA.NMINGREDIENTEPRINC2) THEN
         IF(C_PLANILHA.XLS_NMINGREDIENTEPRINC2 IS NULL OR TRIM(C_PLANILHA.XLS_NMINGREDIENTEPRINC2) = '') THEN
            V_INGREDIENTEPRINC2 := NULL;
         ELSE
            BEGIN
               SELECT MAX(NRINGREDIENTEPRINC) 
                 INTO V_INGREDIENTEPRINC2
                 FROM INGREDIENTEPRINC 
                WHERE UPPER(NMINGREDIENTEPRINC) = UPPER(C_PLANILHA.XLS_NMINGREDIENTEPRINC2);
            EXCEPTION 
                WHEN NO_DATA_FOUND THEN
                   V_INGREDIENTEPRINC2 := NULL;
            END;
            IF (V_INGREDIENTEPRINC2 IS NULL) THEN
                BEGIN
                   NOVO_CODIGO('INGREDIENTEPRINC',V_INGREDIENTEPRINC2, 1, V_NRORG);
                   INSERT INTO INGREDIENTEPRINC(NRINGREDIENTEPRINC, NMINGREDIENTEPRINC, NRORG, NRORGULTATU, NRORGINCLUSAO) VALUES (V_INGREDIENTEPRINC2, C_PLANILHA.XLS_NMINGREDIENTEPRINC2, V_NRORG, V_NRORG, V_NRORG);
                END;
            END IF;
         END IF;
      ELSE
         V_INGREDIENTEPRINC2 := C_PLANILHA.NRINGREDIENTEPRINC2;
      END IF;

      /*TIPO DE CORTE*/
      IF MODIFICADO(C_PLANILHA.XLS_NMAPRERECE, C_PLANILHA.NMAPRERECE)THEN
         IF(C_PLANILHA.XLS_NMAPRERECE IS NULL OR TRIM(C_PLANILHA.XLS_NMAPRERECE) = '') THEN
            V_APRERECE := NULL;
         ELSE
            BEGIN
               SELECT MAX(CDAPRERECE)
                 INTO V_APRERECE
                 FROM APRERECE 
                WHERE UPPER(NMAPRERECE) = UPPER(C_PLANILHA.XLS_NMAPRERECE);
            EXCEPTION 
                WHEN NO_DATA_FOUND THEN
                   V_APRERECE := NULL;
            END;
            IF (V_APRERECE IS NULL) THEN
                BEGIN
                   SELECT MAX(TO_NUMBER(CDAPRERECE)) INTO V_APRERECE FROM APRERECE;
                   V_APRERECE := LPAD(V_APRERECE + 1,3,'0');
                   INSERT INTO APRERECE(CDAPRERECE, NMAPRERECE, NRORG, NRORGULTATU, NRORGINCLUSAO) VALUES (V_APRERECE, C_PLANILHA.XLS_NMAPRERECE, V_NRORG, V_NRORG, V_NRORG);
                END;
            END IF;
         END IF;
      ELSE
         V_APRERECE := C_PLANILHA.CDAPRERECE;
      END IF; 

      /*MODO DE PREPARO*/
      IF MODIFICADO(C_PLANILHA.XLS_NMFORMAPREPARO, C_PLANILHA.NMFORMAPREPARO)THEN
         IF(C_PLANILHA.XLS_NMFORMAPREPARO IS NULL OR TRIM(C_PLANILHA.XLS_NMFORMAPREPARO) = '') THEN
            V_FORMAPREPARO := NULL;
         ELSE
            BEGIN
               SELECT MAX(NRFORMAPREPARO)
                 INTO V_FORMAPREPARO
                 FROM FORMAPREPARO 
                WHERE UPPER(NMFORMAPREPARO) = UPPER(C_PLANILHA.XLS_NMFORMAPREPARO);
            EXCEPTION 
                WHEN NO_DATA_FOUND THEN
                   V_FORMAPREPARO := NULL;
            END;
            IF (V_FORMAPREPARO IS NULL) THEN
                BEGIN
                   NOVO_CODIGO('FORMAPREPARO',V_FORMAPREPARO, 1, V_NRORG);
                   INSERT INTO FORMAPREPARO(NRFORMAPREPARO, NMFORMAPREPARO, NRORG, NRORGULTATU, NRORGINCLUSAO) VALUES (V_FORMAPREPARO, C_PLANILHA.XLS_NMFORMAPREPARO, V_NRORG, V_NRORG, V_NRORG);
                END;
            END IF;
         END IF;
      ELSE
         V_FORMAPREPARO := C_PLANILHA.NRFORMAPREPARO;
      END IF;  
      
      /*ATRATIVIDADE*/
      IF MODIFICADO(C_PLANILHA.XLS_NMATRATIVIDADEPRATO, C_PLANILHA.NMATRATIVIDADEPRATO)THEN
         IF(C_PLANILHA.XLS_NMATRATIVIDADEPRATO IS NULL OR TRIM(C_PLANILHA.XLS_NMATRATIVIDADEPRATO) = '') THEN
            V_ATRATIVIDADEPRATO := NULL;
         ELSE
            BEGIN
               SELECT MAX(NRATRATIVIDADEPRATO)
                 INTO V_ATRATIVIDADEPRATO
                 FROM ATRATIVIDADEPRATO 
                WHERE CDFILIAL = P_CDFILIAL AND UPPER(NMATRATIVIDADEPRATO) = UPPER(C_PLANILHA.XLS_NMATRATIVIDADEPRATO);
            EXCEPTION 
                WHEN NO_DATA_FOUND THEN
                   V_ATRATIVIDADEPRATO := NULL;
            END;
            IF (V_ATRATIVIDADEPRATO IS NULL) THEN
                INSERE_LISTA_ERRO(C_PLANILHA.NRINDICE,'atratividade_invalida',V_STATUS);
            END IF;
         END IF;
      ELSE
         V_ATRATIVIDADEPRATO := C_PLANILHA.NRATRATIVIDADEPRATO;
      END IF; 
      
      /*GRUPO DE PRATO*/
      IF MODIFICADO(C_PLANILHA.XLS_NMGRUPOPRATO,C_PLANILHA.NMGRUPOPRATO)THEN
         IF(C_PLANILHA.XLS_NMGRUPOPRATO IS NULL OR TRIM(C_PLANILHA.XLS_NMGRUPOPRATO) = '') THEN /*SE O GRUPO DE PRATO MUDOU PARA VAZIO, ENTAO DEVE EXCLUIR O PRATO DO CADASTRO DO GRUPO DE PRATO*/
            DELETE FROM ITGRUPOPRATOSERV WHERE NRITGRUPOPRATOSERV = C_PLANILHA.NRITGRUPOPRATOSERV;
         ELSE
            BEGIN
               SELECT MAX(NRGRUPOPRATOSERV)
                 INTO V_NRGRUPOPRATOSERV
                 FROM GRUPOPRATOSERV GS INNER JOIN GRUPOPRATO G ON GS.NRGRUPOPRATO = G.NRGRUPOPRATO
                WHERE G.CDFILIAL = P_CDFILIAL AND GS.CDSERVFILI = P_CDSERVFILI AND G.IDTIPORESTRICAO = P_IDTIPORESTRICAO AND
                      UPPER(G.NMGRUPOPRATO) = UPPER(C_PLANILHA.XLS_NMGRUPOPRATO);
            EXCEPTION 
                WHEN NO_DATA_FOUND THEN
                   V_NRGRUPOPRATOSERV := NULL;
            END;
            IF (V_NRGRUPOPRATOSERV IS NULL) THEN
                INSERE_LISTA_ERRO(C_PLANILHA.NRINDICE,'grupoprato_invalido',V_STATUS);
            ELSE
               BEGIN
                  DELETE FROM ITGRUPOPRATOSERV WHERE NRITGRUPOPRATOSERV = C_PLANILHA.NRITGRUPOPRATOSERV;
                  NOVO_CODIGO('ITGRUPOPRATOSERV', V_NRITGRUPOPRATOSERV, 1, V_NRORG);
                  INSERT INTO ITGRUPOPRATOSERV(NRITGRUPOPRATOSERV, CDFILAUXPRAT, CDPRATO, NRGRUPOPRATOSERV, NRORG, NRORGULTATU, NRORGINCLUSAO) 
                     VALUES(V_NRITGRUPOPRATOSERV,C_PLANILHA.CDFILAUXPRAT, C_PLANILHA.CDPRATO, V_NRGRUPOPRATOSERV, V_NRORG, V_NRORG, V_NRORG);
               END;
            END IF;
         END IF;
      END IF;     
      
      /*SE A LINHA DEU ALGUM ERRO, PASSA PARA A PROXIMA E NAO INSERE*/  
      IF(V_STATUS <> 'OK')THEN
         CONTINUE;
      ELSE
         IF(C_PLANILHA.PRATO_PARAMETRIZADO IS NULL) THEN
            BEGIN
               INSERT INTO PARAMPRATFILIAL(CDFILIAL, CDFILAUXPRAT, CDPRATO, IDCOMPLEXIDADE, IDPREPREPARO, IDCOR, NRINGREDIENTEPRINC1, NRINGREDIENTEPRINC2, CDAPRERECE, NRFORMAPREPARO, IDATRATIVIDADE, NRATRATIVIDADEPRATO, NRORG, NRORGULTATU, NRORGINCLUSAO)
               VALUES(C_PLANILHA.CDFILIAL, C_PLANILHA.CDFILAUXPRAT, C_PLANILHA.CDPRATO, V_COMPLEXIDADE, V_IDPREPREPARO, V_COR, V_INGREDIENTEPRINC1, V_INGREDIENTEPRINC2, V_APRERECE, V_FORMAPREPARO, 'BAIXA',V_ATRATIVIDADEPRATO, V_NRORG, V_NRORG, V_NRORG);
            EXCEPTION
               WHEN DUP_VAL_ON_INDEX THEN
                  UPDATE PARAMPRATFILIAL
                     SET IDCOMPLEXIDADE = V_COMPLEXIDADE,
                         IDPREPREPARO = V_IDPREPREPARO,
                         IDCOR = V_COR,
                         NRINGREDIENTEPRINC1 = V_INGREDIENTEPRINC1,
                         NRINGREDIENTEPRINC2 = V_INGREDIENTEPRINC2,
                         CDAPRERECE = V_APRERECE,
                         NRFORMAPREPARO = V_FORMAPREPARO,
                         NRATRATIVIDADEPRATO = V_ATRATIVIDADEPRATO
                   WHERE CDFILIAL = C_PLANILHA.CDFILIAL AND CDFILAUXPRAT = C_PLANILHA.CDFILAUXPRAT AND CDPRATO = C_PLANILHA.CDPRATO;
            END;
         ELSE
            UPDATE PARAMPRATFILIAL 
               SET IDCOMPLEXIDADE = V_COMPLEXIDADE, 
                   IDPREPREPARO = V_IDPREPREPARO, 
                   IDCOR = V_COR, 
                   NRINGREDIENTEPRINC1 = V_INGREDIENTEPRINC1, 
                   NRINGREDIENTEPRINC2 = V_INGREDIENTEPRINC2, 
                   CDAPRERECE = V_APRERECE, 
                   NRFORMAPREPARO = V_FORMAPREPARO, 
                   NRATRATIVIDADEPRATO = V_ATRATIVIDADEPRATO
             WHERE CDFILIAL = C_PLANILHA.CDFILIAL AND CDFILAUXPRAT = C_PLANILHA.CDFILAUXPRAT AND CDPRATO = C_PLANILHA.CDPRATO;
         END IF;
         COMMIT;
      END IF;      
   END LOOP;
   P_RETORNO := V_RETORNO;
END;
/
